function gadget:GetInfo()
	return {
		name = "CustomCommands.lua",
		desc = "Alters UI",
		author = "Argh",
		date = "April 6th, 2008",
		license = "Copyright (C) Wolfe Games, 2008",
		layer = 1,
		enabled = true,
		}
end

local Infantry = {}

local EngineeringTeam = {}

local MegaConstructor = {}

local GroundCombat = {}

local AirCombat = {}

local Factory = {}

local MobileBuilder = {}

local MobileRadar = {}

local Immobile_Combat = {}

local Immobile_NonCombat = {}

local AllUnits = {}

local Null = {}

local EditUnitCmdDesc = Spring.EditUnitCmdDesc
local FindUnitCmdDesc = Spring.FindUnitCmdDesc
local RemoveUnitCmdDesc = Spring.RemoveUnitCmdDesc

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCHED
----------------------------------------------------------------
------------------------------------------------------------------------
function gadget:Initialize()
	for ud,_ in pairs(UnitDefs) do
		if UnitDefs[ud].customParams.unit_ui_category == 'engineeringteam' then
			table.insert(EngineeringTeam,ud,1)
			table.insert(MobileBuilder,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'megaconstructor' then
			table.insert(MegaConstructor,ud,1)
			table.insert(MobileBuilder,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'ground_combat' then
			table.insert(GroundCombat,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'air_combat' then
			table.insert(AirCombat,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'factory' then
			table.insert(Factory,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'mobile_builder' then
			table.insert(MobileBuilder,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'mobile_radar' then
			table.insert(MobileRadar,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'immobile_combat' then
			table.insert(Immobile_Combat,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'immobile_noncombat' then
			table.insert(Immobile_NonCombat,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'infantry' then
			table.insert(Infantry,ud,1)
			table.insert(GroundCombat,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'null' then
			table.insert(Null,ud,1)
		end
	end
end

function gadget:UnitCreated(u, ud, team)
-----------------------------------------------------BUTTON REMOVAL
	if Null[ud] then
		local cmdID
		for posCommand = 0,50,1 do
			cmdID = FindUnitCmdDesc(u, posCommand)
			if cmdID ~= nil then
				RemoveUnitCmdDesc(u, cmdID)
			end
			cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
			if cmdID ~= nil then
				RemoveUnitCmdDesc(u, cmdID)
			end
		end			
	end

	if MegaConstructor[ud] then
		local cmdID
		
		cmdID = FindUnitCmdDesc(u, CMD.STOP)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end	
	
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.FIGHT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.RESTORE)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end						
	end

	if EngineeringTeam[ud] then
		local cmdID
		cmdID = FindUnitCmdDesc(u, CMD.CAPTURE) -- Special Hack command, "replaces" Capture
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/HACK.png",
			tooltip = "Allows Engineering Teams to take control of Ancient relics.\r\nHint: if you use more than one Engineering team, it will happen faster.",
			})
		end
	end	

	if Infantry[ud] then
		local cmdID
		cmdID = FindUnitCmdDesc(u, CMD.CAPTURE) -- Special Capture command, "replaces" Capture
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/CAPTURE.png",
			tooltip = "This unit can capture buildings and go inside them when captured.\r\nHint: if you use more than one unit, it will happen faster.",
			})
		end
		cmdID = FindUnitCmdDesc(u, CMD.RESTORE)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
	end	
	
	if GroundCombat[ud] then
		--NOTHING HERE FOR NOW
	end
	
	if AirCombat[ud] then
		--NOTHING HERE FOR NOW
	end	
	
	if Factory[ud] then
		local cmdID
		
		cmdID = FindUnitCmdDesc(u, CMD.STOP)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end						
	end		

	if Immobile_Combat[ud] then
		--NOTHING HERE FOR NOW	
	end

	if Immobile_NonCombat[ud] then
		local cmdID	
	
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.STOP)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.AISELECT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end		
	end

	if MobileBuilder[ud] then
		local cmdID	
	
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.FIGHT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
	end
	
	if MobileRadar[ud] then
		local cmdID	
	
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.FIGHT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end	
	end
--------------------------------------------------------------END BUTTON REMOVAL	
		
--------------------------------------------------------------BUTTON REPLACEMENT

-------------------------------------------------------------------------------------------------------------START MAIN
	if AllUnits[ud] then
		local cmdID
		
		cmdID = FindUnitCmdDesc(u, CMD.STOP)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/STOP.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.MOVE)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/MOVE.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.PATROL)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/PATROL.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.FIGHT)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/FIGHT.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.ATTACK)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/ATTACK.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.AREA_ATTACK)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/AREA_ATTACK.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.GUARD)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/GUARD.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.AISELECT)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/AI_SELECT.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.REPAIR)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/REPAIR.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.FIRE_STATE)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/FIRE_STATE1.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.MOVE_STATE)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/MOVE_STATE0.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.LOAD_UNITS)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/LOAD_UNITS.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.UNLOAD_UNITS)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/UNLOAD_UNITS.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.ONOFF)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/ONOFF0.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.RECLAIM)-- Special hack, "Reclaim" becomes "Recycle"
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name = "",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/RECLAIM.png",
		tooltip = "Recycle allows you to convert natural resources, such as junk, trash...\r\n...plants and even old buildings into usable sources of Materials and Power.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.CLOAK)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/resistance_button_background01.tif",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.STOCKPILE)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/resistance_button_background02.tif",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.RESTORE)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/resistance_button_background03.tif",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/resistance_button_background04.tif",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.TRAJECTORY)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/resistance_button_background05.tif",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.RESURRECT)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/resistance_button_background01.tif",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.AUTOREPAIRLEVEL)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/resistance_button_background03.tif",
			})
		end

		cmdID = FindUnitCmdDesc(u, CMD.WAIT)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/WAIT.png",
			})
		end
	end
-------------------------------------------------------------------------------------------------------------END MAIN						
end

--////////////////////////////////////////////////////////////////////
--------------------------------------------------------------------------------------------------------------REAL-TIME BUTTONS
function gadget:AllowCommand(u, ud, team, cmd, param, opts)
---------------------------------------------------------------------------------------MOBILE BUILDERS

	
---------------------------------------------------------------------------------------END MOBILE BUILDERS
---------------------------------------------------------------------------------------MOVE_STATE
	if cmd  == CMD.MOVE_STATE then
		local STATE = Spring.GetUnitStates(u)
		local moveState = STATE.movestate
		local cmdID = FindUnitCmdDesc(u, CMD.MOVE_STATE)
		if  moveState == 0 then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/MOVE_STATE0.png",
			})
		end
		if moveState == 1 then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/MOVE_STATE1.png",
			})
		end
		if moveState == 2 then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/MOVE_STATE2.png",
			})
		end
	return CMD.MOVE_STATE
	end
---------------------------------------------------------------------------------------END MOVE_STATE
---------------------------------------------------------------------------------------FIRE_STATE	
	if cmd  == CMD.FIRE_STATE then
		local STATE = Spring.GetUnitStates(u)
		local fireState = STATE.firestate
		local cmdID = FindUnitCmdDesc(u, CMD.FIRE_STATE)
		if  fireState == 0 then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/FIRE_STATE0.png",
			})
		end
		if fireState == 1 then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/FIRE_STATE1.png",
			})
		end
		if fireState == 2 then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/FIRE_STATE2.png",
			})
		end
	return CMD.FIRE_STATE
	end
---------------------------------------------------------------------------------------END FIRE_STATE
---------------------------------------------------------------------------------------ONOFF	
	if cmd  == CMD.ONOFF then
		local STATE = Spring.GetUnitStates(u)
		local onOff = STATE.active
		local cmdID = FindUnitCmdDesc(u, CMD.ONOFF)
		if cmdID == nil then return CMD.ONOFF end
		if  onOff == false then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/ONOFF0.png",
			})
		end
		if onOff == true then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/ONOFF1.png",
			})
		end
	return CMD.ONOFF
	end
---------------------------------------------------------------------------------------END ONOFF
	return true
end

----------------------------------------------------------------
------------------------------------------------------------------------
else
------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------UNSYNCHED
----------------------------------------------------------------
-----------------------------------------------END
----------------------------------------------------------------
end