function gadget:GetInfo()
	return 
	{
		name = "Prone",
		desc = "Allows Resistance Troopers to drop prone on command.",
		author = "Argh",
		date = "March 20th, 2008",
		license = "(C) Wolfe Games",
		layer = 1,
		enabled = true
	}
end

local CanProne = {}

local CMD_PRONE = 32610

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCHED
----------------------------------------------------------------
------------------------------------------------------------------------
function gadget:Initialize()
	for ud,_ in pairs(UnitDefs) do
		if UnitDefs[ud].customParams.can_go_prone == 'yes' then
			table.insert(CanProne,ud,1)
		end
	end
end


Prone = {
		id=CMD_PRONE,
		type=CMDTYPE.ICON,
		name="Kneel",
		onlyTexture=true,
		texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/KNEEL.png",
		tooltip="Troopers may drop to one knee.\r\nHint: this makes certain troops more effective on defense.",
		action="change state"
		}

local function GoProneLable(u)
		local cmdID = Spring.FindUnitCmdDesc(u, CMD_PRONE)
		Spring.EditUnitCmdDesc(u, cmdID, {
        		name = "Kneel",
		onlyTexture=true,
		texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/KNEEL.png",
		tooltip="Troopers may drop to one knee.\r\nHint: this makes certain troops more effective on defense.",
  		})		
end
gadgetHandler:RegisterGlobal("GoProneLable", GoProneLable)

local function StandUpLable(u)
		local cmdID = Spring.FindUnitCmdDesc(u, CMD_PRONE)
		Spring.EditUnitCmdDesc(u, cmdID, {
        		name = "Stand Up!",
		onlyTexture=true,
		texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/STAND.png",
		tooltip="Click this button to allow your Trooper to move again.",
  		})		
end
gadgetHandler:RegisterGlobal("StandUpLable", StandUpLable)

function gadget:UnitCreated(u, ud, team)
	if CanProne[Spring.GetUnitDefID(u)] then
		Spring.InsertUnitCmdDesc(u, Prone)
		--local cmdID = Spring.FindUnitCmdDesc(u, CMD.CLOAK)
		--Spring.RemoveUnitCmdDesc(u, cmdID)		
	end
end

function gadget:CommandFallback(u, ud, team, cmd, param, opts)
	if cmd  == CMD_PRONE then
		Spring.CallCOBScript(u, "GoProne", 0)
	return true, true;
	end
	return false
end
------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------END
end