function gadget:GetInfo()
	return {
		name = "Simple GUI, v.3",
		desc = "Squad Trooper UI",
		author = "Argh",
		date = "December 28, 2008",
		license = "(C) Wolfe Games, 2008",
		layer = 0,
		enabled = true,
	}
end

local InitialWait = 1
local Frame, TeamNum, TeamSide
local currentLevelEnergy, storageEnergy, pullEnergy, incomeEnergy, expenseEnergy
local currentLevelMetal, storageMetal, pullMetal, incomeMetal, expenseMetal
local math_floor = math.floor

if (gadgetHandler:IsSyncedCode()) then

function gadget:GameFrame(f)
	if (f < InitialWait) then return
	else
		local temp = Spring.GetTeamList()
		for _,Team in ipairs(temp) do
			currentLevelMetal = Spring.GetTeamResources(Team, 'metal')
			currentLevelMetal = math_floor(currentLevelMetal)	
			Frame = f
            			SendToUnsynced("Resources", Team, currentLevelMetal, Frame, 0)
		end
	if InitialWait == 1 then InitialWait = InitialWait + 31 else InitialWait = InitialWait + 32 end
	end
end
	
else

local myScore = 0
local team = 0
local metal = 0
local frame = 0

local GL_ONE = GL.ONE
local GL_ZERO = GL.ZERO
local GL_DST_COLOR = GL.DST_COLOR
local GL_LESS = GL.LESS
local glTexRect       	= gl.TexRect
local glColor         	= gl.Color
local glDepthTest     	= gl.DepthTest
local glTexture       	= gl.Texture
local glText          	= gl.Text
local glBlending      	= gl.Blending
local glGetViewSizes 	= gl.GetViewSizes
local IsGUIHidden  = Spring.IsGUIHidden
local GetLocalTeamID = Spring.GetLocalTeamID


local x,y = glGetViewSizes()
textSize2 = 32 * (x / 1600)
ScoreX = x * 0.545
ScoreY = y * 0.015

textSize = 32 * (x / 1600)
local buttonBack = 'bitmaps/ui/ButtonTop.png'
local background = 'bitmaps/ui/NewGUItex.png'
local backgroundheight = 0.106667 --current height in pixels, divided by 1200	
local BackGroundXMin = 0 
local BackGroundXMax = x 
local BackGroundYMin = 0
local BackGroundYMax = y * backgroundheight   
local buttonBackXMin = x * 0.84 -- 1600 - 256 / 1600 
local buttonBackYMin = y * backgroundheight
local buttonBackXMax = x
local buttonBackYMax = y * (backgroundheight * 2)
	
MetalX = x * 0.545
MetalY = y * 0.057

function gadget:RecvFromSynced(name, Team, currentLevelMetal, Frame, Score)

	if (name == 'ScoreChanged') then
		team = GetLocalTeamID()
		if team == Team then
			frame = Frame
			myScore = Score

		end
	end

	if (name == 'Resources') then
		team = GetLocalTeamID()
		
		if team == Team then				
			metal = currentLevelMetal
			frame = Frame
		end
  	end
end

function gadget:DrawScreenEffects()
	if frame > 30 then
		if IsGUIHidden() == false then
	    	-------------------------------------------------------------BackGround
		glColor(1,1,1,1)	
		glTexture(background)
		glTexRect(BackGroundXMin,BackGroundYMin,BackGroundXMax,BackGroundYMax)

		glTexture(buttonBack)
		glTexRect(buttonBackXMin,buttonBackYMin,buttonBackXMax,buttonBackYMax)
		-------------------------------------------------------------BackGround
		
		-------------------------------------------------------------Text
		glColor(1.0,0.6,0,1.0)
		glText(metal, MetalX, MetalY, textSize, "n")

		glColor(1.0,0.6,0,1.0)
		glText(myScore, ScoreX, ScoreY, textSize2, "n")

		end
	end
end

end

