function widget:GetInfo()
	return {
		name = "P.U.R.E. Unit Status Display",
		desc = "Shows unit health and other status symbols.",
		author = "Argh",
		date = "August 26, 2008",
		license = "(C) Wolfe Games 2008",
		layer = 55,
		enabled = true
		}
end

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

local ShowStatusList = {}
local ShowShieldList = {}

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--
-- Variable Declarations
--
local glPolygonOffset = gl.PolygonOffset
local glUnit = gl.Unit
local glTexRect = gl.TexRect
local glResetState = gl.ResetState
local GL_SRC_ALPHA = GL.SRC_ALPHA
local GL_ONE_MINUS_SRC_ALPHA = GL.ONE_MINUS_SRC_ALPHA
local GL_ONE = GL.ONE
local GetVisibleUnits = Spring.GetVisibleUnits
local GetUnitTeam = Spring.GetUnitTeam
local GetUnitRadius = Spring.GetUnitRadius
local GetUnitBasePosition = Spring.GetUnitBasePosition
local GetUnitHeading = Spring.GetUnitHeading
local GetUnitDefID = Spring.GetUnitDefID
local GetUnitIsStunned = Spring.GetUnitIsStunned
local IsUnitSelected = Spring.IsUnitSelected
local GetTeamColor = Spring.GetTeamColor
local IsUnitVisible = Spring.IsUnitVisible
local GetGroundNormal = Spring.GetGroundNormal
local GetUnitHealth = Spring.GetUnitHealth
local WorldToScreenCoords = Spring.WorldToScreenCoords
local GetUnitStockpile = Spring.GetUnitStockpile
local GetUnitShieldState = Spring.GetUnitShieldState
local glDepthTest = gl.DepthTest
local GetCameraPosition = Spring.GetCameraPosition
local glColor = gl.Color
local glTexture = gl.Texture
local GL_LEQUAL = GL.LEQUAL
local glBlending = gl.Blending
local glDepthMask = gl.DepthMask
local mathRand = math.random
local GetGroundHeight = Spring.GetGroundHeight
local texture =   "LuaUI/Graphics/Status.tga"
local RandomTexture = "LuaUI/Graphics/Stunned1.tga"
local StatusFrontHealth = "LuaUI/Graphics/StatusFrontHealth.tif"
local StatusFrontBuild = "LuaUI/Graphics/StatusFrontBuild.tif"
local StatusFrontCapture = "LuaUI/Graphics/StatusFrontCapture.tif"
local StatusFrontStockpile = "LuaUI/Graphics/StatusFrontStockpile.tif"
local StatusFrontShield = "LuaUI/Graphics/StatusFrontShield.tif"
local GetUnitViewPosition = Spring.GetUnitViewPosition
local myIDList, id, teamID, r, g, b
local drawBackground, yDisplace, xDisplace = 0,0,0
local barX, barY, offsetBar = 0,0,0
local backgroundSizeX, backgroundSizeY, vX, vY = 0,0,0,0
local frameNumber = 0
local FreezeList = {}
local onState
local yHealth, xHealth = 0,0
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function unitstatus()
	if onState == true then onState = false else onState = true end
end

function widget:Initialize()
	onState = true

	for ud,_ in pairs(UnitDefs) do
		if UnitDefs[ud].customParams.show_status == 'yes' then
			table.insert(ShowStatusList,ud,1)
		end

		if UnitDefs[ud].customParams.show_shield_status == 'yes' then
			table.insert(ShowShieldList,ud,1)
		end
	end

	Spring.SendCommands({"showhealthbars 0"})
	widgetHandler:AddAction("unitstatus", unitstatus)
	Spring.SendCommands({"unbind f9 showhealthbars"})
	Spring.SendCommands({"bind f9 luaui unitstatus"})
end

function widget:Shutdown()
	widgetHandler:RemoveAction("unitstatus", unitstatus)
	Spring.SendCommands({"showhealthbars 1"})
	Spring.SendCommands({"unbind f9 luaui unitstatus"})
	Spring.SendCommands({"bind f9 showhealthbars"})
end

function widget:GameFrame(f)
	if frameNumber > 4 then 
		frameNumber = 0 
	else
		frameNumber = frameNumber + 1
		if frameNumber == 1 then RandomTexture = "LuaUI/Graphics/Stunned1.tga" end
		if frameNumber == 2 then RandomTexture = "LuaUI/Graphics/Stunned2.tga" end
		if frameNumber == 3 then RandomTexture = "LuaUI/Graphics/Stunned3.tga" end
		if frameNumber == 4 then RandomTexture = "LuaUI/Graphics/Stunned4.tga" end
	end
end
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function widget:ViewResize(viewSizeX, viewSizeY)
	xHealth = viewSizeX
	yHealth = viewSizeY
	vX = viewSizeX
	vY = viewSizeY
  
	xHealth = xHealth / 1600
	yHealth = yHealth / 1200
end
widget:ViewResize(widgetHandler:GetViewSizes())

function widget:DrawScreenEffects()
if onState == true then
	
	local health, maxHealth, paralyzeDamage, capture, build = 0,0,0,0,0
	local CurrentCameraX,CurrentCameraY,CurrentCameraZ, fudgefactor = 0,0,0,0
	local ux, uy, uz, healthPercent, buildPercent, capturePercent = 0,0,0,0,0,0
	local drawHealth, drawCapture, drawStockpile, drawShieldStatus, drawBuild = 0,0,0,0,0
	local foo1,foo2,stockpilebuildPercent = 0,0,0
	local enabled,currentPower, maxPower, shieldPercent = 0,0,0,0
	local UnitDef
	
	myIDList = GetVisibleUnits(-1,3000,false)
	if myIDList[1] ~= nil then
		for _,myID in ipairs(myIDList) do
			if (IsUnitVisible(myID)) then
				teamID = GetUnitTeam(myID)
				if (teamID) then
					id = GetUnitDefID(myID)
				    	if ShowStatusList[id] then
						ux, uy, uz, healthPercent, buildPercent, capturePercent = 0,0,0,0,0,0
						drawBackground, drawHealth, drawCapture, drawStockpile, drawShieldStatus, drawBuild = 0,0,0,0,0,0
						foo1,foo2,stockpilebuildPercent = 0,0,0
						enabled,currentPower = 0,0
				        		UnitDef = UnitDefs[id]
				        		ux, uy, uz = GetUnitViewPosition(myID)
				        		ux,uy,uz = WorldToScreenCoords(ux,uy + UnitDef.height + 8,uz)
						health,maxHealth,paralyzeDamage,capture,build = GetUnitHealth(myID)

--------------------------------------------------------------------------------------------------------------------------------------------DYNAMIC SIZING
						CurrentCameraX,CurrentCameraY,CurrentCameraZ = GetCameraPosition()
						CurrentCameraY = CurrentCameraY - Spring.GetGroundHeight(CurrentCameraX,CurrentCameraZ)
						fudgefactor = 1
						if CurrentCameraY > 1000 then
							fudgefactor = 1000 / CurrentCameraY
							if fudgefactor < 0.3 then
								fudgefactor = 0.3
							end
						else
							fudgefactor = 1.0	
						end
						
						backgroundSizeX = 32 * xHealth * fudgefactor
						backgroundSizeY = 16 * yHealth * fudgefactor
						barX = 23.5 * xHealth * fudgefactor
						barY = 4 * yHealth * fudgefactor
						offsetBar = 16 * yHealth * fudgefactor

						uy = uy + (8.5 * yHealth * fudgefactor) --Kludge, offsets relative Y
						xDisplace = ux + (4.5 * xHealth * fudgefactor) --Kludge, offsets center X for bars
--------------------------------------------------------------------------------------------------------------------------------------------END DYNAMIC SIZING

						if health ~= nil and maxHealth ~= nil then
							if health < (maxHealth - 5) then
								drawBackground = 1
								drawHealth = 1
								healthPercent = (health / maxHealth)
							end
						end
						if build ~= nil and build < 0.99 then
							drawBackground = 1
							drawBuild = 1
							buildPercent = (build / 1)
						end
						if capture ~= nil and capture > 0.01 then
							drawBackground = 1
							drawCapture = 1
							capturePercent = (capture / 1)
						end
						if GetUnitIsStunned(myID) and build == 1 and paralyzeDamage < 2000 then
							FreezeList[#FreezeList+1]=myID
						end
						if GetUnitStockpile(myID) ~= nil then
							foo1,foo2,stockpilebuildPercent = GetUnitStockpile(myID)
							if stockpilebuildPercent > 0.1 then
								drawBackground = 1
								drawStockpile = 1
							end
						end
						if ShowShieldList[id] then
							if GetUnitShieldState(myID) ~= nil then
								enabled,currentPower = GetUnitShieldState(myID)
								if enabled and currentPower > 0.01 then
									drawBackground = 1
									drawShieldStatus = 1
									maxPower = 250
									shieldPercent = currentPower / maxPower
								end
							end
						end
------------------------------------------------------------------------------------------------------------------------------------DRAW STUFF
						-------------------------------------------------------SPECIAL HACK, DON'T DRAW OVER UI POSITION
						if uy < vY * 0.11 or uy < vY * 0.11 * 2 and ux > vX * 0.80 then drawBackground = 0 end
						-------------------------------------------------------END SPECIAL HACK
						if drawBackground == 1 then
							if drawHealth == 1 then
---------------------------------------------------------------------------------------------------------------------------------------------BACKGROUND
								glColor(1,1,1,1)
								glTexture(StatusFrontHealth)
								glTexRect(ux - backgroundSizeX,uy,ux + backgroundSizeX,uy + backgroundSizeY)
--------------------------------------------------------------------------------------------------------------------------------------------- END BACKGROUND
								r = (1 - healthPercent) * 4
								g = (healthPercent) * 2
				        				glTexture(texture)
				        			if (health / maxHealth) > 0.5 then 
									glColor(r, 1.0, 0, 1) 
								else 
									glColor(1, g, 0, 1) 
								end
								yDisplace = (uy + (8.5 * yHealth * fudgefactor))
				        			glTexRect(xDisplace - (barX * healthPercent),yDisplace - barY, xDisplace + (barX * healthPercent), yDisplace + barY)
								-------------------Special kludge here
								uy = uy + offsetBar
								-------------------
							end

							if drawBuild == 1 then
---------------------------------------------------------------------------------------------------------------------------------------------BACKGROUND
								glColor(1,1,1,1)
								glTexture(StatusFrontBuild)
								glTexRect(ux - backgroundSizeX,uy,ux + backgroundSizeX,uy + backgroundSizeY)
--------------------------------------------------------------------------------------------------------------------------------------------- END BACKGROUND
								r = (1 - buildPercent)
								g = (buildPercent) * 2
								glTexture(texture)
								if buildPercent > 0.5 then 
									glColor(1, 1, r, 1) 
								else 
									glColor(1, g, 1, 1) 
								end
								yDisplace = (uy + (8.5 * yHealth * fudgefactor))
				        			glTexRect(xDisplace - (barX * buildPercent),yDisplace - barY, xDisplace + (barX * buildPercent), yDisplace + barY)
								-------------------Special kludge here
								uy = uy + offsetBar
								-------------------
							end

							if drawCapture == 1 then
---------------------------------------------------------------------------------------------------------------------------------------------BACKGROUND
								glColor(1,1,1,1)
								glTexture(StatusFrontCapture)
								glTexRect(ux - backgroundSizeX,uy,ux + backgroundSizeX,uy + backgroundSizeY)
--------------------------------------------------------------------------------------------------------------------------------------------- END BACKGROUND
								r = (1 - capturePercent)
								g = (capturePercent) * 2
								glTexture(texture)
								if capturePercent > 0.5 then 
									glColor(g, r, 1, 1) 
								else 
									glColor(r, g, 1, 1) 
								end
								yDisplace = (uy + (8.5 * yHealth * fudgefactor))
				        			glTexRect(xDisplace - (barX * capturePercent),yDisplace - barY, xDisplace + (barX * capturePercent), yDisplace + barY)
								-------------------Special kludge here
								uy = uy + offsetBar
								-------------------
							end

							if drawStockpile == 1 then
---------------------------------------------------------------------------------------------------------------------------------------------BACKGROUND
								glColor(1,1,1,1)
								glTexture(StatusFrontStockpile)
								glTexRect(ux - backgroundSizeX,uy,ux + backgroundSizeX,uy + backgroundSizeY)
--------------------------------------------------------------------------------------------------------------------------------------------- END BACKGROUND
								r = (1 - stockpilebuildPercent)
								g = (stockpilebuildPercent) * 2
								glTexture(texture)
								if stockpilebuildPercent > 0.5 then
									glColor(g, 1, 1, 1)
								else
									glColor(1, g, 1, 1)
								end
								yDisplace = (uy + (8.5 * yHealth * fudgefactor))
							glTexRect(xDisplace - (barX * stockpilebuildPercent),yDisplace - barY, xDisplace + (barX * stockpilebuildPercent), yDisplace + barY)
								-------------------Special kludge here
								uy = uy + offsetBar
								-------------------
							end

							if drawShieldStatus == 1 then
---------------------------------------------------------------------------------------------------------------------------------------------BACKGROUND
								glColor(1,1,1,1)
								glTexture(StatusFrontShield)
								glTexRect(ux - backgroundSizeX,uy,ux + backgroundSizeX,uy + backgroundSizeY)
--------------------------------------------------------------------------------------------------------------------------------------------- END BACKGROUND
								r = (shieldPercent)
								g = (shieldPercent)
								glTexture(texture)
								if currentPower > 0.5 then
									glColor(1, r, r, 1)
								else
									glColor(g, g, 1, 1)
								end
								yDisplace = (uy + (8.5 * yHealth * fudgefactor))
				        			glTexRect(xDisplace - (barX * shieldPercent),yDisplace - barY, xDisplace + (barX * shieldPercent), yDisplace + barY)
								-------------------Special kludge here
								uy = uy + offsetBar
								-------------------
							end
						end
------------------------------------------------------------------------------------------------------------------------------------END DRAWING
					end
				end
			end
		end
  		glResetState()
	end
end
end

function widget:DrawWorld()
   	glDepthTest(GL_LEQUAL)
   	gl.AlphaTest(GL.GREATER,0)
   	gl.Scissor(true)
	glBlending(GL_SRC_ALPHA, GL_ONE)
	glPolygonOffset(-2,-2)
	glColor(1,1,1,1)
	glTexture(RandomTexture)
	for i = 1,#FreezeList do
		glUnit(FreezeList[i],true)
	end
	glPolygonOffset(0,0)
  	glResetState()
	FreezeList = {}
end
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------