function widget:GetInfo()
  return {
	name="Tooltip Fixes",
	desc="Fixes the Tooltip display to look more professional and fit Merc Squad",
	author="Argh",
	date="September 19th, 2008",
	license="Public Domain, or the least-restrictive rights in your country of residence",
	layer=0,
	enabled=true
	}
end

local string_format = string.format
local string_find = string.find
local math_floor = math.floor
local math_ceil = math.ceil
local glColor = gl.Color
local glText = gl.Text
local  IsGUIHidden = Spring.IsGUIHidden
local GetGameFrame = Spring.GetGameFrame
local glGetViewSizes = gl.GetViewSizes
local GetUnitDefID = Spring.GetUnitDefID
local GetFeatureDefID = Spring.GetFeatureDefID
local GetUnitHealth = Spring.GetUnitHealth
local GetFeatureHealth = Spring.GetFeatureHealth
local GetUnitResources = Spring.GetUnitResources
local GetFeatureResources = Spring.GetFeatureResources
local GetGroundInfo = Spring.GetGroundInfo

local x,y,textSize,gapSize,xOffset, yOffset = 0,0,0,0,0,0
local myType,myTooltip, line1, line2, line3, ud
local health, maxHealth,metalMake,metalUse,energyMake,energyUse, metalVal = 0,0,0,0,0,0,0
local metalUseFix, metalMakeFix, energyUseFix, energyMakeFix = 0,0,0,0
local RemainingMetal, RemainingEnergy = 0,0
local OtherStuff
local ShutDown = 0
local myLine, xLine = 0,0

function widget:Initialize()
	Spring.SendCommands({"tooltip 0"})
end

function widget:ShutDown()
	ShutDown = 1
	Spring.SendCommands({"tooltip 1"})
	widgetHandler:RemoveWidget()
end

function widget:DrawScreenEffects()
	if GetGameFrame() > 1 and IsGUIHidden() == false and ShutDown == 0 then
		x,y = glGetViewSizes()        
		textSize = 16 * (x / 1600)
		gapSize = 26 * (y / 1200)
		xOffset = 15 *( x  / 1600)
		yOffset = 95 * (y / 1200)
	
		OtherStuff = Spring.GetCurrentTooltip():gsub("Energy cost 0 ",""):gsub("Metal cost","Cost: $"):gsub("",""):gsub("PP"," "):gsub("/P"," / "):gsub("",""):gsub("P0","0"):gsub("Build time 75",""):gsub("Metal","RemoveMe")
		myLine = 0
		xLine = 0		
		for line in string.gmatch(OtherStuff, "([^\n]*)\n?") do
			if myLine == 0 then
				glColor(1,1,1,1)
				glText(line,xOffset, yOffset - xLine,textSize, "n")
			end
			if myLine == 1 then
				glColor(1.0,1.0,0.7,1.0)
				glText(line,xOffset, yOffset - xLine,textSize, "n")
			end
			if myLine == 2 then
				glColor(1.0,0.6,0,1.0)
				glText(line,xOffset, yOffset - xLine,textSize, "n")
			end
			if myLine == 3 then
				if string.find(tostring(line),"RemoveMe") then line = "" end
				glColor(0.0,0.8,1.0,1.0)
				glText(line,xOffset, yOffset - xLine,textSize, "n")
			end
			xLine = xLine + gapSize
			myLine = myLine +1
		end
	end
end