// Argh's Squad Troopers Rocket Launcher Guy Script

// This script is copyright (C) Wolfe Games, 2008
// All contents were created by Wolfe Games.

#ifndef RL_GUY_SQTR_H_
#define RL_GUY_SQTR_H_

// This Include is absolutely VITAL.  
// You must call it FIRST.  PERIOD.
// Don't say I didn't warn you ;-)
#include "STANDARD_COMMANDS_SQTR.h"
#include "SoundLibrary_Trooper_SQTR.h"

piece gun_flare;
piece base, hip, mid, chest, thigh_l, thigh_r, shin_l, shin_r, head;
piece shoulder_r, shoulder_l, ruparm, luparm, rloarm, lloarm, gun, ground;

#define BLEEDING_FX 1024+0
#define GUNFLARE_RAPID_RED 1024+1
#define GUNSMOKE_FX 1024+2
#define SMALL_YELLOW_FLASH 1024+3

static-var  bMoving, bAiming, bCanAim, bDying, isTransforming, Transformed, SpeedSetting, WeaponRange, ReloadTime, Accuracy, MyHeading;
#include "DeathAnimations_Trooper_SQTR.h"

#define RUN_SPEED_FAST	6

lua_GoProneLable(arg) { return (0); }
lua_StandUpLable(arg) { return (0); }

ResetAimState()
{
	bCanAim = TRUE;
	set ARMORED to TRUE;
}

ResetArmoredState()
{
	set ARMORED to FALSE;
}

StartBuilding(heading,pitch)
{
	set INBUILDSTANCE to 1;
}

StopBuilding()
{
	set INBUILDSTANCE to 0;
}

QueryNanoPiece(piecenum)
{
	piecenum = base;
}

Walk()
{
/////////////////////////////////////////////////////////////////////RUNNING
///////////////////////////////////////////////////////////////////////////////////////RIGHT LEG
if(NOT isTransforming and NOT Transformed)
{
	if (bMoving)
	{	
		turn hip to x-axis <3> speed <3>*RUN_SPEED_FAST;
		move base to y-axis [1] speed [1]*RUN_SPEED_FAST;
		
		turn thigh_l to x-axis <-30> speed <30>*RUN_SPEED_FAST;
		turn shin_l to x-axis <15> speed <30>*RUN_SPEED_FAST;		
		
		turn thigh_r to x-axis <30> speed <30>*RUN_SPEED_FAST;
		turn shin_r to x-axis <15> speed <15>*RUN_SPEED_FAST;
	
		turn chest to y-axis <6> speed <12>*RUN_SPEED_FAST;
		
		sleep 1000 / RUN_SPEED_FAST;

	}
///////////////////////////////////////////////////////////////////////////////////////FINISH CYCLE
	if (bMoving)
	{	
		
		move base to y-axis [0] speed [1]*RUN_SPEED_FAST;		
		
		turn thigh_l to x-axis <0> speed <30>*RUN_SPEED_FAST;
		turn shin_l to x-axis <0> speed <15>*RUN_SPEED_FAST;
		
		turn thigh_r to x-axis <0> speed <30>*RUN_SPEED_FAST;
		turn shin_r to x-axis <45> speed <30>*RUN_SPEED_FAST;		
				
		sleep 1000 / RUN_SPEED_FAST;
	}		
///////////////////////////////////////////////////////////////////////////////////////LEFT LEG
	if(bMoving)
	{
	
		move base to y-axis [1] speed [1]*RUN_SPEED_FAST;
			
		turn thigh_l to x-axis <30> speed <30>*RUN_SPEED_FAST;
		turn shin_l to x-axis <15> speed <15>*RUN_SPEED_FAST;

		turn thigh_r to x-axis <-30> speed <30>*RUN_SPEED_FAST;
		turn shin_r to x-axis <15> speed <30>*RUN_SPEED_FAST;
		
		turn chest to y-axis <-6> speed <12>*RUN_SPEED_FAST;

		sleep 1000 / RUN_SPEED_FAST;		
	}
	if (bMoving)
	{	
	
		move base to y-axis [0] speed [1]*RUN_SPEED_FAST;	
	
		turn thigh_l to x-axis <0> speed <30>*RUN_SPEED_FAST;
		turn shin_l to x-axis <45> speed <30>*RUN_SPEED_FAST;		
		
		turn thigh_r to x-axis <0> speed <30>*RUN_SPEED_FAST;
		turn shin_r to x-axis <0> speed <15>*RUN_SPEED_FAST;	
				
		sleep 1000 / RUN_SPEED_FAST;
	}
}		
}

WalkLegs()
{
/////////////////////////////////////////////////////////////////////RUNNING
///////////////////////////////////////////////////////////////////////////////////////RIGHT LEG
if(NOT isTransforming and NOT Transformed)
{
	if (bMoving)
	{	
		turn hip to x-axis <3> speed <3>*RUN_SPEED_FAST;
		move base to y-axis [1] speed [1]*RUN_SPEED_FAST;
		
		turn thigh_l to x-axis <-30> speed <30>*RUN_SPEED_FAST;
		turn shin_l to x-axis <15> speed <30>*RUN_SPEED_FAST;		
		
		turn thigh_r to x-axis <30> speed <30>*RUN_SPEED_FAST;
		turn shin_r to x-axis <15> speed <15>*RUN_SPEED_FAST;
		
		sleep 1000 / RUN_SPEED_FAST;

	}
///////////////////////////////////////////////////////////////////////////////////////FINISH CYCLE
	if (bMoving)
	{	
		
		move base to y-axis [0] speed [1]*RUN_SPEED_FAST;		
		
		turn thigh_l to x-axis <0> speed <30>*RUN_SPEED_FAST;
		turn shin_l to x-axis <0> speed <15>*RUN_SPEED_FAST;
		
		turn thigh_r to x-axis <0> speed <30>*RUN_SPEED_FAST;
		turn shin_r to x-axis <45> speed <30>*RUN_SPEED_FAST;		
				
		sleep 1000 / RUN_SPEED_FAST;
	}		
///////////////////////////////////////////////////////////////////////////////////////LEFT LEG
	if(bMoving)
	{
	
		move base to y-axis [1] speed [1]*RUN_SPEED_FAST;
			
		turn thigh_l to x-axis <30> speed <30>*RUN_SPEED_FAST;
		turn shin_l to x-axis <15> speed <15>*RUN_SPEED_FAST;

		turn thigh_r to x-axis <-30> speed <30>*RUN_SPEED_FAST;
		turn shin_r to x-axis <15> speed <30>*RUN_SPEED_FAST;
		
		sleep 1000 / RUN_SPEED_FAST;		
	}
	if (bMoving)
	{	
	
		move base to y-axis [0] speed [1]*RUN_SPEED_FAST;	
	
		turn thigh_l to x-axis <0> speed <30>*RUN_SPEED_FAST;
		turn shin_l to x-axis <45> speed <30>*RUN_SPEED_FAST;		
		
		turn thigh_r to x-axis <0> speed <30>*RUN_SPEED_FAST;
		turn shin_r to x-axis <0> speed <15>*RUN_SPEED_FAST;	
				
		sleep 1000 / RUN_SPEED_FAST;
	}
}		
}

MotionControl()
{
	var transforming, hastransformed, dying, moving, aiming, just_moved, RandomSeed;

	RandomSeed = rand (100 , 150);
	just_moved = TRUE;

	while (TRUE)
	{
		dying = bDying;
		moving = bMoving;
		aiming = bAiming;

		if(dying)
		{
			sleep 20000;
		}

		while(isTransforming or Transformed)
		{
			sleep RandomSeed;
		}
				
		if (moving)
		{
		
			if (aiming)
			{
				bCanAim = TRUE;			
				call-script WalkLegs();
			}

			if (NOT aiming)
			{
				//bCanAim = FALSE;			
				call-script Walk();
			}

			just_moved = TRUE;
		}

		if (NOT moving)
		{
				
			if (just_moved)
			{

				move base to y-axis [0] speed [250];			
				turn hip to x-axis <0> speed <500>;
				
				turn thigh_l to x-axis <0> speed <500>;
				turn shin_l to x-axis <0> speed <500>;	
				
				turn thigh_r to x-axis <0> speed <500>;
				turn shin_r to x-axis <0> speed <500>;
				
				if(!bAiming)
				{
					turn chest to y-axis <0> speed <500>;
					move base to y-axis [0] speed [250];						
				}				

				just_moved = FALSE;
			}
			sleep RandomSeed;
		}
	}
}

GoProne()
{
	if (bDying)
	{
		sleep 20000;
	}	
	if(NOT Transformed)
	{
		bCanAim = FALSE;
		isTransforming = TRUE;
		SET MAX_SPEED to 1;
		sleep 1250;
		
		move hip to y-axis [-5] speed [250];
		
		turn shoulder_r to z-axis <0> speed <500>;
		
		turn ruparm to x-axis <-80> speed <500>;
		turn ruparm to y-axis <10> speed <500>;
		turn ruparm to z-axis <0> speed <500>;
		
		turn rloarm to x-axis <-10> speed <500>;
		turn rloarm to y-axis <0> speed <500>;
		turn rloarm to z-axis <0> speed <500>;
		move rloarm to x-axis [0] speed [250];
		
		turn gun to z-axis <10> speed <500>;
		turn gun to y-axis <0> speed <500>;
		
		turn shoulder_l to z-axis <0> speed <500>;
		
		turn luparm to x-axis <-70> speed <500>;
		turn luparm to y-axis <0> speed <500>;
		turn luparm to z-axis <30> speed <500>;

		move lloarm to x-axis [0] speed [250];
		move lloarm to z-axis [0] speed [250];
		turn lloarm to x-axis <-30> speed <500>;
		turn lloarm to z-axis <0> speed <500>;			

		turn thigh_r to x-axis <-110> speed <500>;
		move thigh_r to z-axis [0] speed [250];
		
		turn shin_r to x-axis <110> speed <500>;
		
		turn thigh_l to x-axis <10> speed <500>;
		move thigh_l to z-axis [0] speed [250];
		turn thigh_l to z-axis <0> speed <500>;
		
		turn shin_l to x-axis <90> speed <500>;
		
		sleep 1250;
		bCanAim = TRUE;
		isTransforming = FALSE;
		Transformed = TRUE;
		GET WEAPON_ACCURACY(-1,(Accuracy * 2 / Accuracy * 3));
		call-script lua_StandUpLable();
		return(0);
	}	
	if(Transformed)
	{
		bCanAim = FALSE;
		isTransforming = TRUE;
		SET MAX_SPEED to 1;
		sleep 1250;
		
		turn mid to y-axis <0> speed <500>;
		turn chest to y-axis <0> speed <500>;		
		
		turn hip to x-axis <0> speed <500>;
		move hip to y-axis [0] speed [250];

		turn shoulder_r to z-axis <0> speed <500>;
		
		turn ruparm to x-axis <-30> speed <500>;
		turn ruparm to y-axis <0> speed <500>;
		turn ruparm to z-axis <0> speed <500>;
		
		turn rloarm to x-axis <-45> speed <500>;
		turn rloarm to z-axis <-45> speed <500>;
		move rloarm to x-axis [0.3] speed [250];
		
		turn gun to z-axis <-15> speed <500>;
		turn gun to y-axis <0> speed <500>;
		
		turn shoulder_l to z-axis <0> speed <500>;
		turn luparm to x-axis <-45> speed <500>;
		turn luparm to y-axis <0> speed <500>;
		turn luparm to z-axis <0> speed <500>;	

		move lloarm to x-axis [-0.3] speed [250];
		move lloarm to z-axis [0] speed [250];		
		turn lloarm to x-axis <-20> speed <500>;
		turn lloarm to z-axis <25> speed <500>;			
		
		turn head to x-axis <0> speed <500>;
		turn shoulder_r to z-axis <0> speed <500>;
		
		turn thigh_r to x-axis <0> speed <500>;
		move thigh_r to z-axis [0] speed [250];
		
		turn shin_r to x-axis <0> speed <500>;
		
		turn thigh_l to x-axis <0> speed <500>;
		move thigh_l to z-axis [0] speed [250];
		turn thigh_l to z-axis <0> speed <500>;
		
		turn shin_l to x-axis <0> speed <500>;
		sleep 1250;
		bCanAim = TRUE;
		isTransforming = FALSE;
		Transformed = FALSE;
		SET MAX_SPEED to SpeedSetting;
		GET WEAPON_ACCURACY(-1,Accuracy);
		call-script lua_GoProneLable();		
		return(0);
	}
}


StartMoving()
{
	bMoving = TRUE;
}

StopMoving()
{
	bMoving = FALSE;
	return (0);
}

Create()
{
	ReloadTime = GET WEAPON_RELOADTIME(1);
	Accuracy = GET WEAPON_ACCURACY(1);
	WeaponRange = GET WEAPON_RANGE(1);
	hide gun_flare;

	// Initial State
	bDying = FALSE;
	bMoving = FALSE;
	bAiming = FALSE;
	bCanAim = TRUE;
	isTransforming = FALSE;
	Transformed = FALSE;
	SpeedSetting = GET MAX_SPEED;

	while( get BUILD_PERCENT_LEFT )
	{
		sleep 100;
	}

	turn ruparm to x-axis <-30> speed <500>;
	turn ruparm to z-axis <0> speed <500>;
	turn rloarm to x-axis <-45> speed <500>;
	turn rloarm to z-axis <-45> speed <500>;
	move rloarm to x-axis [0.3] speed [250];
	turn gun to y-axis <0> speed <500>;
	turn gun to z-axis <-15> speed <500>;
	
	turn luparm to x-axis <-45> speed <500>;
	turn luparm to y-axis <0> speed <500>;
	move lloarm to x-axis [-0.3] speed [250];
	turn lloarm to x-axis <-20> speed <500>;
	turn lloarm to z-axis <25> speed <500>;	
	turn mid to y-axis <0> speed <500>;
	turn chest to y-axis <0> speed <500>;
	
	//start-script Timer();
	start-script MotionControl();	
}

RestoreAfterDelay()
{
	sleep 4000;
	if(NOT isTransforming and NOT Transformed)
	{
		turn ruparm to x-axis <-30> speed <500>;
		turn ruparm to z-axis <0> speed <500>;
		turn rloarm to x-axis <-45> speed <500>;
		turn rloarm to z-axis <-45> speed <500>;
		move rloarm to x-axis [0.3] speed [250];
		turn gun to y-axis <0> speed <500>;
		turn gun to z-axis <-15> speed <500>;
		
		turn luparm to x-axis <-45> speed <500>;
		turn luparm to y-axis <0> speed <500>;
		move lloarm to x-axis [-0.3] speed [250];
		turn lloarm to x-axis <-20> speed <500>;
		turn lloarm to z-axis <25> speed <500>;	
		turn mid to y-axis <0> speed <500>;
		turn chest to y-axis <0> speed <500>;
	} else { return (0);}
	
	bAiming = FALSE;
	bCanAim = TRUE;
}

AimFromWeapon1(piecenum)
{
	piecenum = chest;
	return (0);
}

AimWeapon1(heading,pitch)
{
	var RandomSeed;
	RandomSeed = RAND(150, 200);
	
	signal SIG_AIM1;
	set-signal-mask SIG_AIM1;

	bAiming = TRUE;
		
	if (NOT bCanAim)
	{
		sleep 100;
		return(0);
	}
	
	if(NOT Transformed)
	{
	turn ruparm to x-axis <-45> speed <500>;
	turn ruparm to z-axis <-15> speed <500>;
	turn rloarm to x-axis <-45> speed <500>;
	turn rloarm to z-axis <0> speed <500>;
	move rloarm to x-axis [0] speed [250];
	turn gun to y-axis <15> speed <500>;
	turn gun to z-axis <15> speed <500>;
	
	turn luparm to x-axis <-90> speed <500>;
	turn luparm to y-axis <-30> speed <500>;
	move lloarm to x-axis [0] speed [250];
	turn lloarm to x-axis <-15> speed <500>;
	turn lloarm to z-axis <15> speed <500>;		
	
	turn chest to y-axis heading/2 speed <120>;
	turn mid to y-axis heading/2 speed <120>;

	wait-for-turn chest around y-axis;
	
	start-script RestoreAfterDelay();
	MyHeading = heading;
	}
	return (1);
}

Shot1(piecenum)
{
	emit-sfx GUNFLARE_RAPID_RED from gun_flare;
	emit-sfx SMALL_YELLOW_FLASH from ground;
	turn chest to y-axis MyHeading / 2 + <-5> now;
}	

QueryWeapon1(piecenum)
{

	piecenum = gun_flare;		
		
}

FireWeapon1()
{
	return (0);
}

Killed(severity, corpsetype)
{	
	hide gun;
	bDying = 1;	
	call-script DeathAnimation_Trooper();
	return(0);
}	

#endif // RL_GUY_SQTR_H_