// Argh's SQTR Squad Transport Script

// This script is copyright (C) Wolfe Games, 2008
// All contents were created by Wolfe Games.

#ifndef TRANSPORT_SQTR_H_
#define TRANSPORT_SQTR_H_

// This Include is absolutely VITAL.  
// You must call it FIRST.  PERIOD.
// Don't say I didn't warn you ;-)
#include "STANDARD_COMMANDS_SQTR.h"

piece base, body;
piece motor_lf, motor_lr, motor_rf, motor_rr;
piece blades_lf, blades_lr, blades_rf, blades_rr;
piece winglight1, winglight2, winglight3, winglight4;

///////////////////////////////////////FX RESERVED FOR EXPLOSIONS
#define CHOPPER_DUST_FX 1024+9
#define FAST_LIGHT_RED 1024+10
///////////////////////////////////////END RESERVED

static-var RandomMovement, RandomX, RandomY, RandomZ, TurnX, TurnY, TurnZ;
lua_RemoveMe(arg) { return(0);}
CountDown()
{
	play-sound("Argh_StartChopper",25);
	Sleep 50000;
	RandomMovement = 0;
	move body to y-axis [60] speed [10];
	turn motor_lf to x-axis <90> speed <60>;
	turn motor_lr to x-axis <90> speed <60>;
	turn motor_rf to x-axis <90> speed <60>;
	turn motor_rr to x-axis <90> speed <60>;
	wait-for-move body along y-axis;
	turn body to x-axis <-15> speed <5>;
	move body to y-axis [1500] speed [200];
	move body to z-axis [1500] speed [200];
	wait-for-move body along y-axis;
	call-script lua_RemoveMe();
}

RandomMove()
{
	while(TRUE)
	{
		if(RandomMovement == 1)
		{
			RandomX = Rand(-5,5);
			RandomY = Rand(-5,5);
			RandomZ = Rand(-5,5);
			TurnX = Rand(-5,5);
			TurnY = Rand(-5,5);
			TurnZ = Rand(-5,5);
			move body to x-axis RandomX * [1] speed [5];
			move body to y-axis RandomY * [1] + [50] speed [5];
			move body to z-axis RandomZ * [1] speed [5];
			turn body to x-axis TurnX * <1> speed <1>;
			turn body to y-axis TurnY * <1> speed <1>;
			turn body to z-axis TurnZ * <1> speed <1>;
			sleep 750;
		} else {
			sleep 10000;
		}
	}
}

Dust()
{
	while(TRUE)
	{
		if(RandomMovement == 1)
		{
			emit-sfx FAST_LIGHT_RED from winglight1;
			emit-sfx FAST_LIGHT_RED from winglight2;
			emit-sfx FAST_LIGHT_RED from winglight3;
			emit-sfx FAST_LIGHT_RED from winglight4;
			emit-sfx CHOPPER_DUST_FX from base;
			sleep 250;
		} else {
			sleep 10000;
		}
	}
}

Create()
{	
	set BUGGER_OFF to 1;
	set YARD_OPEN to 1;
	set INBUILDSTANCE to 1;
	move body to y-axis [50] now;
	RandomMovement = 1;
	spin blades_lf around y-axis speed <5000>;
	spin blades_lr around y-axis speed <5000>;
	spin blades_rf around y-axis speed <-5000>;
	spin blades_rr around y-axis speed <-5000>;
	start-script CountDown();
	start-script RandomMove();
	start-script Dust();
	return (0);
}

QueryNanoPiece(piecenum)
{
	piecenum = base;
	return (0);
}

Activate()
{
	set BUGGER_OFF to 1;
	set YARD_OPEN to 1;
	set INBUILDSTANCE to 1;
}

Deactivate()
{
	play-sound("Argh_DoorMechanism",15);
	return (0);
}

QueryBuildInfo(piecenum)
{
	piecenum = base;
	return (0);
}

Killed(severity, corpsetype)
{	  	  	 	  	   	
	return(0);
}
#endif // TRANSPORT_SQTR_H_